Subject: Re: [PATCH 1/3] pci: VPD access timeout increase

From: Ben Hutchings <[email-masked]>
Date: Thu, 4 Sep 2008 15:19:46 +0100

Matthew Wilcox wrote:
> On Wed, Sep 03, 2008 at 03:57:13PM -0700, Stephen Hemminger wrote:
> > Accessing the VPD area can take a long time. There are comments in the
> > SysKonnect vendor driver that it can take up to 25ms.  The existing vpd
> > access code fails consistently on my hardware.
> 
> Wow, that's slow.  If you were to try to read all 32k, it'd take more
> than three minutes!  (I presume it doesn't actually have as much as 32k).
> 
> > Change the access routines to:
> >   * use a mutex rather than spinning with IRQ's disabled and lock held
> >   * have a longer timeout
> >   * call schedule while spinning to provide some responsivness
> 
> I agree with your approach, but have one minor comment:
> 
> > -	spin_lock_irq(&vpd->lock);
> > +	mutex_lock(&vpd->lock);
> 
> This should be:
> 
> +	if (mutex_lock_interruptible(&vpd->lock))
> +		return -EINTR;
[...]

This is fine for the sysfs case, but not if this is called during device
probe - we don't want signals to modprobe to break device initialisation,
do we?

Ben.

-- 
Ben Hutchings, Senior Software Engineer, Solarflare Communications
Not speaking for my employer; that's the marketing department's job.
They asked us to note that Solarflare product names are trademarked.